autowatch = 1;
outlets = 1;

var RenderContext = "project";

var sketch = new JitterObject("jit.gl.sketch", RenderContext);
sketch.immediate = 1;

var projection_pos = [1., 1., 1.];
var projector_lens_angle = 45;

function projector(vals)
{
	projection_pos = arrayfromargs(arguments);
}

function lens_angle(val)
{
	projector_lens_angle = val;
}

function projectiveTextureTransform()
{
	var matrix;
	var lookat = [0., 0., 0.];//render.lookat;
	var up = [0., 1., 0.];//render.up;
	
	sketch.glmatrixmode("modelview");
	sketch.glpushmatrix();

		sketch.glloadidentity();
		
		//texture scale-bias matrix
		sketch.gltranslate(0.5, 0.5, 0.5);
		sketch.glscale(0.5, 0.5, 0.5);
		
		//light projection matrix (lens angle, aspect ratio, near clip, far clip)
		sketch.gluperspective(projector_lens_angle, 320./240., 0.1, 100.);

		//light view matrix
		sketch.glulookat(projection_pos[0], projection_pos[1], projection_pos[2],
							lookat[0], lookat[1], lookat[2],
							up[0], up[1], up[2]);
		
		//get the matrix
		matrix = sketch.glget("modelview_matrix");

	sketch.glpopmatrix();
	
	outlet(0, "lightToTex", matrix)
}

function modelToWorldTransform(px, py, pz, ra, rx, ry, rz, sx, sy, sz)
{
	var matrix;
	var position = [px, py, pz];
	var rotate = [ra, rx, ry, rz];
	var scale = [sx, sy, sz];
	
	//get camera's view matrix
	sketch.glmatrixmode("modelview");
	sketch.glpushmatrix();
		sketch.glloadidentity();
		sketch.gltranslate(position[0], position[1], position[2]);
		sketch.glrotate(rotate[0], rotate[1], rotate[2], rotate[3]);
		sketch.glscale(scale[0], scale[1], scale[2]);
		
		matrix = sketch.glget("modelview_matrix");
		
	sketch.glpopmatrix();
	
	outlet(0, "modelToWorld", matrix)
}

function print4x4_mat(mat)
{
		post(mat[0].toPrecision(4) + "\t\t" +  mat[4].toPrecision(4) + "\t\t" + mat[8].toPrecision(4) + "\t\t" + mat[12].toPrecision(4) + "\n");
		post(mat[1].toPrecision(4) + "\t\t" +  mat[5].toPrecision(4) + "\t\t" + mat[9].toPrecision(4) + "\t\t" + mat[13].toPrecision(4) + "\n");
		post(mat[2].toPrecision(4) + "\t\t" +  mat[6].toPrecision(4) + "\t\t" + mat[10].toPrecision(4) + "\t\t" + mat[14].toPrecision(4) + "\n");
		post(mat[3].toPrecision(4) + "\t\t" +  mat[7].toPrecision(4) + "\t\t" + mat[11].toPrecision(4) + "\t\t" + mat[15].toPrecision(4) + "\n");
}